/*
 * This file is part of Transitime.org
 * 
 * Transitime.org is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License (GPL) as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * Transitime.org is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Transitime.org .  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * For handling SIRI API.
 * <p>
 * Examples of SIRI feed output can be seen at:
 *   http://user47094.vs.easily.co.uk/siri/schema/1.4/examples/index.htm
 *   http://user47094.vs.easily.co.uk/siri/schema/1.4/examples/exs_stopMonitoring_response.xml
 * <p>  
 * NYC MTA info can be found at
 *   http://bustime.mta.info/wiki/Developers/SIRIVehicleMonitoring
 *   http://bustime.mta.info/wiki/Developers/SIRIStopMonitoring
 *   http://bustime.mta.info/wiki/Developers/SIRIMonitoredVehicleJourney
 *<p>   
 * UTA has a documented SIRI feed at
 *  http://developer.rideuta.com/VehicleByVehcileInstructions.aspx
 *  http://developer.rideuta.com/StopMonitoringInstructions.aspx
 *
 *
 * @author SkiBu Smith
 *
 */
package org.transitclock.api.data.siri;